Name:           gcc-python-plugin
Version:        0.17
Release:        1.5%{?dist}
Summary:        GCC plugin that embeds Python

Group:          Development/Languages
License:        GPLv3+
URL:            https://github.com/davidmalcolm/gcc-python-plugin
Source0:        %{name}-%{version}.tar.gz

Patch0001: 0001-Fix-typo-in-release-notes.patch
Patch0002: 0002-Fix-typo-in-basics.rst.patch
Patch0003: 0003-gcc-python-pretty-printer-fix-GCC-8.3-compatibility.patch
Patch0004: 0004-Added-ability-to-get-the-result-of-DECL_ORIGINAL_TYP.patch
Patch0005: 0005-tests-exercise-gcc.TypeDecl.original_type.patch
Patch0006: 0006-.travis.yml-add-gcc-9.patch
Patch0007: 0007-Build-on-Python-3.8.patch
Patch0008: 0008-Don-t-include-params.h-if-building-with-GCC-10.patch
Patch0009: 0009-Update-gcc-python-wrapper.c-for-Python-3.8.patch
Patch0010: 0010-Link-with-libpython3.8.so.patch
Patch0011: 0011-Add-PLUGIN_FINISH_PARSE_FUNCTION-support.patch
Patch0012: 0012-Add-get_location.patch
Patch0013: 0013-Add-main_input_filename.patch
Patch0014: 0014-Add-stub-for-types.patch
Patch0015: 0015-Add-current_function_decl.patch
Patch0016: 0016-Add-context.patch
Patch0017: 0017-Add-main_variant-for-types.patch
Patch0018: 0018-Add-print_declaration-support-besides-dump_generic_n.patch
Patch0019: 0019-Make-static-attribute-writtable.patch
Patch0020: 0020-Make-initial-attribute-writeable.patch
Patch0021: 0021-Make-public-attribute-writable.patch
Patch0022: 0022-Add-external-attribute.patch
Patch0023: 0023-Make-location-hasher-robust.patch
Patch0024: 0024-Add-PLUGIN_INCLUDE_FILE-callback.patch
Patch0025: 0025-Add-decl.attributes.patch
Patch0026: 0026-Add-referring-and-referer-to-variables.patch
Patch0027: 0027-Add-VarDecl.node-points-to-varpool-nodes.patch
Patch0028: 0028-Add-general-purpose-walk_tree.patch
Patch0029: 0029-Add-inline-attr-to-function-decl.patch
Patch0030: 0030-Workaround-GCC-bug-of-attributes-with-parameters.patch
Patch0031: 0031-Use-the-libpython3-in-Makefile.patch

# gcc version should be more than 6.5.1
BuildRequires:	gcc >= 6.5.1
BuildRequires:	gcc-plugin-devel >= 6.5.1
BuildRequires:	gcc-c++ >= 6.5.1

# Various python runtimes to build the plugin against:
BuildRequires:	python3
BuildRequires:	python3-devel

# "six" is used at buildtime:
BuildRequires:	python3-six

# pygments is used when running the selftests:
BuildRequires:	python3-pygments

# lxml is used when running the selftests:
BuildRequires:	python3-lxml

Requires:	gcc-plugin-devel >= 6.5.1
Requires:	python3-libs

ExclusiveArch:	x86_64 aarch64

%global gcc_plugins_dir %(gcc --print-file-name=plugin)

%description
Plugins for embedding various versions of Python within GCC

%prep
%autosetup -p1

%build
make PYTHON=python3 PYTHON_CONFIG=python3-config PLUGIN_DSO=python.so plugin print-gcc-version

%install
mkdir -p %{buildroot}/usr/lib64/gcc-python-plugin
mkdir -p %{buildroot}/%{gcc_plugins_dir}

install -m 755 python.so %{buildroot}/usr/lib64/gcc-python-plugin/python.so
install -m 755 gcc-c-api/libgcc-c-api.so \
		%{buildroot}/%{gcc_plugins_dir}/libgcc-c-api.so

%files
/usr/lib64/gcc-python-plugin/python.so
%{gcc_plugins_dir}/libgcc-c-api.so

%dir
/usr/lib64/gcc-python-plugin

%changelog
* Mon Aug 7 2023 Tianchen Ding <dtcccc@linux.alibaba.com> - 0.17-1.5
- rebuild for gcc-8.5.0-18.0.3.an8

* Fri Mar 17 2023 happy_orange <songnannan@linux.alibaba.com> - 0.17-1.4
- add release number

* Wed Mar 15 2023 happy_orange <songnannan@linux.alibaba.com> - 0.17-1.3
- rebuild for gcc

* Wed Jun 15 2022 Erwei Deng <erwei@linux.alibaba.com> 0.17-1.2
- Simplify the spec file to build only on Python3
- Workaround GCC bug of the no_sanitize attributes with parameters

* Wed Feb  9 2022 Yihao Wu <wuyihao@linux.alibaba.com> 0.17-1.1
- Simplify the spec file to build only on Python2
- Add inline attr to function decl
- Add general purpose walk_tree
- Add VarDecl.node points to varpool nodes
- Add referring and referer to variables
- Add decl.attributes
- Add PLUGIN_INCLUDE_FILE callback
- Make location hasher robust
- Add external attribute
- Make public attribute writable
- Make initial attribute writeable
- Make static attribute writtable
- Add print_declaration support besides dump_generic_node
- Add main_variant for types
- Add context
- Add current_function_decl
- Add stub for types
- Add main_input_filename
- Add get_location
- Add PLUGIN_FINISH_PARSE_FUNCTION support
- Link with libpython3.8.so
- Update gcc-python-wrapper.c for Python 3.8
- Don't include "params.h" if building with GCC 10
- Build on Python 3.8
- .travis.yml: add gcc-9
- tests: exercise gcc.TypeDecl.original_type
- Added ability to get the result of DECL_ORIGINAL_TYPE
- gcc-python-pretty-printer: fix GCC 8.3 compatibility

* Thu Jan 24 2019 David Malcolm <dmalcolm@redhat.com> - 0.17-1
- This releases adds support for gcc 9 (along with continued support for
  gcc 4.6, 4.7, 4.8, 4.9, 5, 6, 7, and 8).
- Unfortunately, the reference-count checker no longer works for gcc 7
  onwards, so it is disabled when embedded in those builds of gcc.
- Additionally, this release contains the following improvements:
  the plugin can now be built in a separate build directory from the
  source directory (thanks to Tom de Vries)
- gcc-with-cpychecker gained a --cpychecker-verbose option

* Sat May  5 2018 David Malcolm <dmalcolm@redhat.com> - 0.16-1
- This releases adds support for gcc 7 and gcc 8 (along with continued support for gcc 4.6, 4.7, 4.8, 4.9, 5 and 6).
- The upstream location for the plugin has moved from fedorahosted.org to https://github.com/davidmalcolm/gcc-python-plugin
- Additionally, this release contains the following improvements:
  add gcc.RichLocation for GCC 6 onwards
  gcc.Location
  add caret, start, finish attributes for GCC 7 onwards
  add gcc.Location.offset_column() method

* Mon Feb  6 2012 David Malcolm <dmalcolm@redhat.com> - 0.9-1
- 0.9

* Tue Jan 10 2012 David Malcolm <dmalcolm@redhat.com> - 0.8-1
- 0.8

* Tue Aug  2 2011 David Malcolm <dmalcolm@redhat.com> - 0.6-1
- 0.6

* Wed Jul 27 2011 David Malcolm <dmalcolm@redhat.com> - 0.5-1
- 0.5
- examples are now in an "examples" subdirectory

* Tue Jul 26 2011 David Malcolm <dmalcolm@redhat.com> - 0.4-1
- 0.4
- add requirement on pygments
- run the upstream test suites during %%check

* Mon Jul 25 2011 David Malcolm <dmalcolm@redhat.com> - 0.3-1
- add requirements on python-six and python3-six
- add %%check section (empty for now)
- set PYTHON and PLUGIN_PYTHONPATH during each build; install support files
into build-specific directories below the gcc plugin dir
- add helper gcc-with-python scripts, with man pages
- package the license
- add example scripts
- add explicit BR on gmp-devel (rhbz#725569)

* Tue May 24 2011 David Malcolm <dmalcolm@redhat.com> - 0.1-1
- initial packaging
